/*
 * SumsListener.java
 *
 * Created on 05 June 2006, 13:51
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package jim.sums3;

import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Date;
import javax.servlet.ServletContextEvent;
import jim.common.AppInfoUtil;
import jim.common.BundleUtil;
import jim.common.Logger;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.hibernate.HibernateException;
import org.hibernate.Session;

/**
 *
 * @author briggsj
 */
public class SumsListener implements javax.servlet.ServletContextListener {
    
    static private Log log = Logger.getLog(SumsListener.class);
    
    static private SimpleDateFormat df = new SimpleDateFormat("yyyyMMdd.HHmm");
    
    /** Creates a new instance of SumsListener */
    public SumsListener() {
    }
    
    public void contextInitialized(ServletContextEvent sce) {
        AppInfoUtil.init(sce.getServletContext());
        
        identifyVersion();
        noteStartTime();
        startHibernate();
    }
    
    private void noteStartTime() {
        Date now = new Date();
        String nowstr = df.format(now);
        AppInfoUtil.setParameter("app.start", nowstr);
        log.info("SUMS application start time=" + nowstr);
    }
    
    private void identifyVersion() {
        String version = BundleUtil.getProperty("resources/pums", "version", "0.0.0");
        AppInfoUtil.setParameter("app.version", version);
        log.info("SUMS application version=" + version);
    }
    
    private void startHibernate() throws HibernateException {
        Session hiber = HibernateUtil.getSession();
        String url;
        try {
            url = hiber.connection().getMetaData().getURL();
        } catch (HibernateException ex) {
            ex.printStackTrace();
            url = "HibernateException";
        } catch (SQLException ex) {
            ex.printStackTrace();
            url = "SQLException";
        }
        HibernateUtil.closeSession();
        AppInfoUtil.setParameter("app.dburl", url);
        log.info("SUMS application database URL=" + url);
    }
    
    public void contextDestroyed(ServletContextEvent sce) {
        log.info("SUMS context destroyed");
    }
    
}
