/*
 * SumsLoginAction.java
 *
 * Created on 04 July 2006, 13:55
 */

package jim.sums3.admin.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import jim.sums3.admin.LoginForm;
import jim.sums3.admin.LoginUtil;
import jim.sums3.pojo.Person;
import jim.sums3.process.PersonDAO;
import jim.util.struts.JimActionErrors;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMessages;

/**
 *
 * @author briggsj
 * @version
 */

public class SumsLoginAction extends Action {
    
    private static final org.apache.commons.logging.Log log = org.apache.commons.logging.LogFactory.getLog(SumsLoginAction.class);
    
    /* forward name="success" path="" */
    private final static String SUCCESS = "success";
    private final static String FAILURE = "failure";
    
    /**
     * This is the action called from the Struts framework.
     * @param mapping The ActionMapping used to select this instance.
     * @param form The optional ActionForm bean for this request.
     * @param request The HTTP Request we are processing.
     * @param response The HTTP Response we are processing.
     * @throws java.lang.Exception
     * @return
     */
    public ActionForward execute(ActionMapping mapping, ActionForm  form,
            HttpServletRequest request, HttpServletResponse response)
            throws Exception {
        
        LoginForm lform = (LoginForm)form;
        PersonDAO pd = new PersonDAO();
        Person p = pd.findByAuthName(lform.getName(), lform.getPassword());
        if (p != null) {
            LoginUtil.setupLoginSession(lform.getName(), p, request);
            return mapping.findForward(SUCCESS);
        } else {
            JimActionErrors errors = new JimActionErrors();
            errors.addGlobal("error.login.invalid", "Invalid username/password");
            this.saveErrors(request, (ActionMessages)errors);
            return mapping.findForward(FAILURE);
        }
    }
    
}
