/*
 * ShowProjectAction.java
 *
 * Created on 12 July 2006, 10:18
 */

package jim.sums3.general.actions;

import java.io.IOException;
import javax.servlet.ServletException;
import jim.common.JimFatalException;
import jim.sums3.admin.LoginUtil;
import jim.sums3.general.forms.ProjectChangeForm;
import jim.sums3.pojo.FinalProject;
import jim.sums3.pojo.Person;
import jim.sums3.process.FinalProjectDAO;
import jim.util.struts.JimActionErrors;
import jim.util.struts.StrutsUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionForward;
/**
 *
 * @author briggsj
 * @version
 */

public class EditProjectAction extends jim.sums3.Sums3BaseAction {
    
    private static final Log log = LogFactory.getLog(EditProjectAction.class);
    
    public ActionForward doPumsExecute(StrutsUtils su) throws IOException, ServletException, JimFatalException {
        ProjectChangeForm form = (ProjectChangeForm)su.getForm();
        Person user = LoginUtil.getPerson(su.getRequest());
        FinalProjectDAO dao = new FinalProjectDAO();
        FinalProject project = null;
        try {
            project = dao.changeProject(form, user);
        } catch (JimFatalException ex) {
            log.debug("Caught JimFatalException");
            JimActionErrors errors = new JimActionErrors();
            errors.addGlobal("error.project.id", Long.toString(form.getProjectId()));
        } finally {
            if (project == null) {
                project = dao.findById(form.getProjectId());
            }
            su.setAttribute("project", project, su.REQUEST_SCOPE);
            return su.successOrFailure();
        }
    }
    
    
}
