/*
 * ProjectChangeForm.java
 *
 * Created on 12 July 2006, 15:51
 */

package jim.sums3.general.forms;

import javax.servlet.http.HttpServletRequest;
import jim.util.struts.JimActionErrors;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.DynaActionForm;

/**
 *
 * @author briggsj
 * @version
 */

public class ProjectChangeForm extends ActionForm {
    
    
    
    /**
     *
     */
    public ProjectChangeForm() {
        super();
        // TODO Auto-generated constructor stub
    }

    /**
     * Holds value of property reason.
     */
    private String reason;

    /**
     * Getter for property reason.
     * @return Value of property reason.
     */
    public String getReason() {
        return this.reason;
    }

    /**
     * Setter for property reason.
     * @param reason New value of property reason.
     */
    public void setReason(String reason) {
        this.reason = reason;
    }

    static private final int MIN_REASON_LENGTH = 8;
    static private final int MIN_TITLE_LENGTH = 10;
    
    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
        JimActionErrors errors = new JimActionErrors();
        
        errors.add(super.validate(mapping, request));
        if ((Long)project.get("projectId") <= 0L) {
            errors.add("projectId", new ActionMessage("error.id.required"));
        }
        if (reason == null || reason.length() < MIN_REASON_LENGTH) {
            errors.add("reason", new ActionMessage("error.project.reason", MIN_REASON_LENGTH));
        }
        if ((String)project.get("projectTitle") == null || ((String)project.get("projectTitle")).length() < MIN_TITLE_LENGTH) {
            errors.add("projectTitle", new ActionMessage("error.project.title", MIN_TITLE_LENGTH));
        }
        return errors;
    }

    /**
     * Holds value of property project.
     */
    private DynaActionForm project;

    /**
     * Getter for property project.
     * @return Value of property project.
     */
    public DynaActionForm getProject() {
        return this.project;
    }

    /**
     * Setter for property project.
     * @param project New value of property project.
     */
    public void setProject(DynaActionForm project) {
        this.project = project;
    }

    /**
     * Holds value of property projectId.
     */
    private long projectId;

    /**
     * Getter for property projectId.
     * @return Value of property projectId.
     */
    public long getProjectId() {
        return this.projectId;
    }

    /**
     * Setter for property projectId.
     * @param projectId New value of property projectId.
     */
    public void setProjectId(long projectId) {
        this.projectId = projectId;
    }
}
