package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class AuditTrail.
 * @see jim.sums3.pojo.AuditTrail
 * @author Hibernate Tools
 */
public class AuditTrailHome {

    private static final Log log = LogFactory.getLog(AuditTrailHome.class);

    
    public void persist(AuditTrail transientInstance) {
        log.debug("persisting AuditTrail instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(AuditTrail instance) {
        log.debug("attaching dirty AuditTrail instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(AuditTrail instance) {
        log.debug("attaching clean AuditTrail instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(AuditTrail persistentInstance) {
        log.debug("deleting AuditTrail instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public AuditTrail merge(AuditTrail detachedInstance) {
        log.debug("merging AuditTrail instance");
        try {
            AuditTrail result = (AuditTrail) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public AuditTrail findById(long id) {
        log.debug("getting AuditTrail instance with id: " + id);
        try {
            AuditTrail instance = (AuditTrail) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.AuditTrail", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<AuditTrail> findByExample(Example instance) {
        log.debug("finding AuditTrail instance by example");
        try {
            List<AuditTrail> results = (List<AuditTrail>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.AuditTrail")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}