package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class CategoryMarks.
 * @see jim.sums3.pojo.CategoryMarks
 * @author Hibernate Tools
 */
public class CategoryMarksHome {

    private static final Log log = LogFactory.getLog(CategoryMarksHome.class);

    
    public void persist(CategoryMarks transientInstance) {
        log.debug("persisting CategoryMarks instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(CategoryMarks instance) {
        log.debug("attaching dirty CategoryMarks instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(CategoryMarks instance) {
        log.debug("attaching clean CategoryMarks instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(CategoryMarks persistentInstance) {
        log.debug("deleting CategoryMarks instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public CategoryMarks merge(CategoryMarks detachedInstance) {
        log.debug("merging CategoryMarks instance");
        try {
            CategoryMarks result = (CategoryMarks) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public CategoryMarks findById(long id) {
        log.debug("getting CategoryMarks instance with id: " + id);
        try {
            CategoryMarks instance = (CategoryMarks) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.CategoryMarks", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<CategoryMarks> findByExample(Example instance) {
        log.debug("finding CategoryMarks instance by example");
        try {
            List<CategoryMarks> results = (List<CategoryMarks>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.CategoryMarks")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}