package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class CategoryOptionCriteria.
 * @see jim.sums3.pojo.CategoryOptionCriteria
 * @author Hibernate Tools
 */
public class CategoryOptionCriteriaHome {

    private static final Log log = LogFactory.getLog(CategoryOptionCriteriaHome.class);

    
    public void persist(CategoryOptionCriteria transientInstance) {
        log.debug("persisting CategoryOptionCriteria instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(CategoryOptionCriteria instance) {
        log.debug("attaching dirty CategoryOptionCriteria instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(CategoryOptionCriteria instance) {
        log.debug("attaching clean CategoryOptionCriteria instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(CategoryOptionCriteria persistentInstance) {
        log.debug("deleting CategoryOptionCriteria instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public CategoryOptionCriteria merge(CategoryOptionCriteria detachedInstance) {
        log.debug("merging CategoryOptionCriteria instance");
        try {
            CategoryOptionCriteria result = (CategoryOptionCriteria) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public CategoryOptionCriteria findById(long id) {
        log.debug("getting CategoryOptionCriteria instance with id: " + id);
        try {
            CategoryOptionCriteria instance = (CategoryOptionCriteria) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.CategoryOptionCriteria", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<CategoryOptionCriteria> findByExample(Example instance) {
        log.debug("finding CategoryOptionCriteria instance by example");
        try {
            List<CategoryOptionCriteria> results = (List<CategoryOptionCriteria>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.CategoryOptionCriteria")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}