package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class CategoryOptionGroups.
 * @see jim.sums3.pojo.CategoryOptionGroups
 * @author Hibernate Tools
 */
public class CategoryOptionGroupsHome {

    private static final Log log = LogFactory.getLog(CategoryOptionGroupsHome.class);

    
    public void persist(CategoryOptionGroups transientInstance) {
        log.debug("persisting CategoryOptionGroups instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(CategoryOptionGroups instance) {
        log.debug("attaching dirty CategoryOptionGroups instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(CategoryOptionGroups instance) {
        log.debug("attaching clean CategoryOptionGroups instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(CategoryOptionGroups persistentInstance) {
        log.debug("deleting CategoryOptionGroups instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public CategoryOptionGroups merge(CategoryOptionGroups detachedInstance) {
        log.debug("merging CategoryOptionGroups instance");
        try {
            CategoryOptionGroups result = (CategoryOptionGroups) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public CategoryOptionGroups findById(long id) {
        log.debug("getting CategoryOptionGroups instance with id: " + id);
        try {
            CategoryOptionGroups instance = (CategoryOptionGroups) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.CategoryOptionGroups", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<CategoryOptionGroups> findByExample(Example instance) {
        log.debug("finding CategoryOptionGroups instance by example");
        try {
            List<CategoryOptionGroups> results = (List<CategoryOptionGroups>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.CategoryOptionGroups")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}