package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class CategoryOptions.
 * @see jim.sums3.pojo.CategoryOptions
 * @author Hibernate Tools
 */
public class CategoryOptionsHome {

    private static final Log log = LogFactory.getLog(CategoryOptionsHome.class);

    
    public void persist(CategoryOptions transientInstance) {
        log.debug("persisting CategoryOptions instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(CategoryOptions instance) {
        log.debug("attaching dirty CategoryOptions instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(CategoryOptions instance) {
        log.debug("attaching clean CategoryOptions instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(CategoryOptions persistentInstance) {
        log.debug("deleting CategoryOptions instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public CategoryOptions merge(CategoryOptions detachedInstance) {
        log.debug("merging CategoryOptions instance");
        try {
            CategoryOptions result = (CategoryOptions) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public CategoryOptions findById(long id) {
        log.debug("getting CategoryOptions instance with id: " + id);
        try {
            CategoryOptions instance = (CategoryOptions) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.CategoryOptions", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<CategoryOptions> findByExample(Example instance) {
        log.debug("finding CategoryOptions instance by example");
        try {
            List<CategoryOptions> results = (List<CategoryOptions>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.CategoryOptions")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}