package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class CohortCoordinators.
 * @see jim.sums3.pojo.CohortCoordinators
 * @author Hibernate Tools
 */
public class CohortCoordinatorsHome {

    private static final Log log = LogFactory.getLog(CohortCoordinatorsHome.class);

    
    public void persist(CohortCoordinators transientInstance) {
        log.debug("persisting CohortCoordinators instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(CohortCoordinators instance) {
        log.debug("attaching dirty CohortCoordinators instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(CohortCoordinators instance) {
        log.debug("attaching clean CohortCoordinators instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(CohortCoordinators persistentInstance) {
        log.debug("deleting CohortCoordinators instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public CohortCoordinators merge(CohortCoordinators detachedInstance) {
        log.debug("merging CohortCoordinators instance");
        try {
            CohortCoordinators result = (CohortCoordinators) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public CohortCoordinators findById(long id) {
        log.debug("getting CohortCoordinators instance with id: " + id);
        try {
            CohortCoordinators instance = (CohortCoordinators) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.CohortCoordinators", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<CohortCoordinators> findByExample(Example instance) {
        log.debug("finding CohortCoordinators instance by example");
        try {
            List<CohortCoordinators> results = (List<CohortCoordinators>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.CohortCoordinators")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}