package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class Cohort.
 * @see jim.sums3.pojo.Cohort
 * @author Hibernate Tools
 */
public class CohortHome {

    private static final Log log = LogFactory.getLog(CohortHome.class);

    
    public void persist(Cohort transientInstance) {
        log.debug("persisting Cohort instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(Cohort instance) {
        log.debug("attaching dirty Cohort instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(Cohort instance) {
        log.debug("attaching clean Cohort instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(Cohort persistentInstance) {
        log.debug("deleting Cohort instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Cohort merge(Cohort detachedInstance) {
        log.debug("merging Cohort instance");
        try {
            Cohort result = (Cohort) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public Cohort findById(long id) {
        log.debug("getting Cohort instance with id: " + id);
        try {
            Cohort instance = (Cohort) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.Cohort", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<Cohort> findByExample(Example instance) {
        log.debug("finding Cohort instance by example");
        try {
            List<Cohort> results = (List<Cohort>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.Cohort")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}