package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class Contacts.
 * @see jim.sums3.pojo.Contacts
 * @author Hibernate Tools
 */
public class ContactsHome {

    private static final Log log = LogFactory.getLog(ContactsHome.class);

    
    public void persist(Contacts transientInstance) {
        log.debug("persisting Contacts instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(Contacts instance) {
        log.debug("attaching dirty Contacts instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(Contacts instance) {
        log.debug("attaching clean Contacts instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(Contacts persistentInstance) {
        log.debug("deleting Contacts instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Contacts merge(Contacts detachedInstance) {
        log.debug("merging Contacts instance");
        try {
            Contacts result = (Contacts) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public Contacts findById(long id) {
        log.debug("getting Contacts instance with id: " + id);
        try {
            Contacts instance = (Contacts) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.Contacts", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<Contacts> findByExample(Example instance) {
        log.debug("finding Contacts instance by example");
        try {
            List<Contacts> results = (List<Contacts>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.Contacts")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}