package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class Emailmessages.
 * @see jim.sums3.pojo.Emailmessages
 * @author Hibernate Tools
 */
public class EmailmessagesHome {

    private static final Log log = LogFactory.getLog(EmailmessagesHome.class);

    
    public void persist(Emailmessages transientInstance) {
        log.debug("persisting Emailmessages instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(Emailmessages instance) {
        log.debug("attaching dirty Emailmessages instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(Emailmessages instance) {
        log.debug("attaching clean Emailmessages instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(Emailmessages persistentInstance) {
        log.debug("deleting Emailmessages instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Emailmessages merge(Emailmessages detachedInstance) {
        log.debug("merging Emailmessages instance");
        try {
            Emailmessages result = (Emailmessages) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public Emailmessages findById(String id) {
        log.debug("getting Emailmessages instance with id: " + id);
        try {
            Emailmessages instance = (Emailmessages) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.Emailmessages", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<Emailmessages> findByExample(Example instance) {
        log.debug("finding Emailmessages instance by example");
        try {
            List<Emailmessages> results = (List<Emailmessages>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.Emailmessages")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}