package jim.sums3.pojo;

import java.math.BigDecimal;
import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class Emails.
 * @see jim.sums3.pojo.Emails
 * @author Hibernate Tools
 */
public class EmailsHome {

    private static final Log log = LogFactory.getLog(EmailsHome.class);

    
    public void persist(Emails transientInstance) {
        log.debug("persisting Emails instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(Emails instance) {
        log.debug("attaching dirty Emails instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(Emails instance) {
        log.debug("attaching clean Emails instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(Emails persistentInstance) {
        log.debug("deleting Emails instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Emails merge(Emails detachedInstance) {
        log.debug("merging Emails instance");
        try {
            Emails result = (Emails) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public Emails findById(BigDecimal id) {
        log.debug("getting Emails instance with id: " + id);
        try {
            Emails instance = (Emails) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.Emails", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<Emails> findByExample(Example instance) {
        log.debug("finding Emails instance by example");
        try {
            List<Emails> results = (List<Emails>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.Emails")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}