package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class FinalProject.
 * @see jim.sums3.pojo.FinalProject
 * @author Hibernate Tools
 */
public class FinalProjectHome {

    private static final Log log = LogFactory.getLog(FinalProjectHome.class);

    
    public void persist(FinalProject transientInstance) {
        log.debug("persisting FinalProject instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(FinalProject instance) {
        log.debug("attaching dirty FinalProject instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(FinalProject instance) {
        log.debug("attaching clean FinalProject instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(FinalProject persistentInstance) {
        log.debug("deleting FinalProject instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public FinalProject merge(FinalProject detachedInstance) {
        log.debug("merging FinalProject instance");
        try {
            FinalProject result = (FinalProject) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public FinalProject findById(long id) {
        log.debug("getting FinalProject instance with id: " + id);
        try {
            FinalProject instance = (FinalProject) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.FinalProject", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<FinalProject> findByExample(FinalProject instance) {
        log.debug("finding FinalProject instance by example");
        try {
            List<FinalProject> results = (List<FinalProject>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.FinalProject")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}