package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class Ideas2.
 * @see jim.sums3.pojo.Ideas2
 * @author Hibernate Tools
 */
public class Ideas2Home {

    private static final Log log = LogFactory.getLog(Ideas2Home.class);

    
    public void persist(Ideas2 transientInstance) {
        log.debug("persisting Ideas2 instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(Ideas2 instance) {
        log.debug("attaching dirty Ideas2 instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(Ideas2 instance) {
        log.debug("attaching clean Ideas2 instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(Ideas2 persistentInstance) {
        log.debug("deleting Ideas2 instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Ideas2 merge(Ideas2 detachedInstance) {
        log.debug("merging Ideas2 instance");
        try {
            Ideas2 result = (Ideas2) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public Ideas2 findById(long id) {
        log.debug("getting Ideas2 instance with id: " + id);
        try {
            Ideas2 instance = (Ideas2) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.Ideas2", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<Ideas2> findByExample(Example instance) {
        log.debug("finding Ideas2 instance by example");
        try {
            List<Ideas2> results = (List<Ideas2>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.Ideas2")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}