package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class MarkFormCategories.
 * @see jim.sums3.pojo.MarkFormCategories
 * @author Hibernate Tools
 */
public class MarkFormCategoriesHome {

    private static final Log log = LogFactory.getLog(MarkFormCategoriesHome.class);

    
    public void persist(MarkFormCategories transientInstance) {
        log.debug("persisting MarkFormCategories instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(MarkFormCategories instance) {
        log.debug("attaching dirty MarkFormCategories instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(MarkFormCategories instance) {
        log.debug("attaching clean MarkFormCategories instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(MarkFormCategories persistentInstance) {
        log.debug("deleting MarkFormCategories instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public MarkFormCategories merge(MarkFormCategories detachedInstance) {
        log.debug("merging MarkFormCategories instance");
        try {
            MarkFormCategories result = (MarkFormCategories) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public MarkFormCategories findById(long id) {
        log.debug("getting MarkFormCategories instance with id: " + id);
        try {
            MarkFormCategories instance = (MarkFormCategories) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.MarkFormCategories", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<MarkFormCategories> findByExample(Example instance) {
        log.debug("finding MarkFormCategories instance by example");
        try {
            List<MarkFormCategories> results = (List<MarkFormCategories>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.MarkFormCategories")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}