package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class MarkForms.
 * @see jim.sums3.pojo.MarkForms
 * @author Hibernate Tools
 */
public class MarkFormsHome {

    private static final Log log = LogFactory.getLog(MarkFormsHome.class);

    
    public void persist(MarkForms transientInstance) {
        log.debug("persisting MarkForms instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(MarkForms instance) {
        log.debug("attaching dirty MarkForms instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(MarkForms instance) {
        log.debug("attaching clean MarkForms instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(MarkForms persistentInstance) {
        log.debug("deleting MarkForms instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public MarkForms merge(MarkForms detachedInstance) {
        log.debug("merging MarkForms instance");
        try {
            MarkForms result = (MarkForms) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public MarkForms findById(long id) {
        log.debug("getting MarkForms instance with id: " + id);
        try {
            MarkForms instance = (MarkForms) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.MarkForms", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<MarkForms> findByExample(Example instance) {
        log.debug("finding MarkForms instance by example");
        try {
            List<MarkForms> results = (List<MarkForms>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.MarkForms")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}