package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class MarkerCapacity.
 * @see jim.sums3.pojo.MarkerCapacity
 * @author Hibernate Tools
 */
public class MarkerCapacityHome {

    private static final Log log = LogFactory.getLog(MarkerCapacityHome.class);

    
    public void persist(MarkerCapacity transientInstance) {
        log.debug("persisting MarkerCapacity instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(MarkerCapacity instance) {
        log.debug("attaching dirty MarkerCapacity instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(MarkerCapacity instance) {
        log.debug("attaching clean MarkerCapacity instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(MarkerCapacity persistentInstance) {
        log.debug("deleting MarkerCapacity instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public MarkerCapacity merge(MarkerCapacity detachedInstance) {
        log.debug("merging MarkerCapacity instance");
        try {
            MarkerCapacity result = (MarkerCapacity) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public MarkerCapacity findById(long id) {
        log.debug("getting MarkerCapacity instance with id: " + id);
        try {
            MarkerCapacity instance = (MarkerCapacity) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.MarkerCapacity", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<MarkerCapacity> findByExample(Example instance) {
        log.debug("finding MarkerCapacity instance by example");
        try {
            List<MarkerCapacity> results = (List<MarkerCapacity>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.MarkerCapacity")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}