package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class MarkerType.
 * @see jim.sums3.pojo.MarkerType
 * @author Hibernate Tools
 */
public class MarkerTypeHome {

    private static final Log log = LogFactory.getLog(MarkerTypeHome.class);

    
    public void persist(MarkerType transientInstance) {
        log.debug("persisting MarkerType instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(MarkerType instance) {
        log.debug("attaching dirty MarkerType instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(MarkerType instance) {
        log.debug("attaching clean MarkerType instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(MarkerType persistentInstance) {
        log.debug("deleting MarkerType instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public MarkerType merge(MarkerType detachedInstance) {
        log.debug("merging MarkerType instance");
        try {
            MarkerType result = (MarkerType) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public MarkerType findById(long id) {
        log.debug("getting MarkerType instance with id: " + id);
        try {
            MarkerType instance = (MarkerType) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.MarkerType", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<MarkerType> findByExample(Example instance) {
        log.debug("finding MarkerType instance by example");
        try {
            List<MarkerType> results = (List<MarkerType>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.MarkerType")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}