package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class Marks.
 * @see jim.sums3.pojo.Marks
 * @author Hibernate Tools
 */
public class MarksHome {

    private static final Log log = LogFactory.getLog(MarksHome.class);

    
    public void persist(Marks transientInstance) {
        log.debug("persisting Marks instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(Marks instance) {
        log.debug("attaching dirty Marks instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(Marks instance) {
        log.debug("attaching clean Marks instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(Marks persistentInstance) {
        log.debug("deleting Marks instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Marks merge(Marks detachedInstance) {
        log.debug("merging Marks instance");
        try {
            Marks result = (Marks) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public Marks findById(long id) {
        log.debug("getting Marks instance with id: " + id);
        try {
            Marks instance = (Marks) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.Marks", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<Marks> findByExample(Example instance) {
        log.debug("finding Marks instance by example");
        try {
            List<Marks> results = (List<Marks>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.Marks")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}