package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class OptionMarks.
 * @see jim.sums3.pojo.OptionMarks
 * @author Hibernate Tools
 */
public class OptionMarksHome {

    private static final Log log = LogFactory.getLog(OptionMarksHome.class);

    
    public void persist(OptionMarks transientInstance) {
        log.debug("persisting OptionMarks instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(OptionMarks instance) {
        log.debug("attaching dirty OptionMarks instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(OptionMarks instance) {
        log.debug("attaching clean OptionMarks instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(OptionMarks persistentInstance) {
        log.debug("deleting OptionMarks instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public OptionMarks merge(OptionMarks detachedInstance) {
        log.debug("merging OptionMarks instance");
        try {
            OptionMarks result = (OptionMarks) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public OptionMarks findById(long id) {
        log.debug("getting OptionMarks instance with id: " + id);
        try {
            OptionMarks instance = (OptionMarks) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.OptionMarks", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<OptionMarks> findByExample(Example instance) {
        log.debug("finding OptionMarks instance by example");
        try {
            List<OptionMarks> results = (List<OptionMarks>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.OptionMarks")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}