package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class PersonEmail.
 * @see jim.sums3.pojo.PersonEmail
 * @author Hibernate Tools
 */
public class PersonEmailHome {

    private static final Log log = LogFactory.getLog(PersonEmailHome.class);

    
    public void persist(PersonEmail transientInstance) {
        log.debug("persisting PersonEmail instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(PersonEmail instance) {
        log.debug("attaching dirty PersonEmail instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(PersonEmail instance) {
        log.debug("attaching clean PersonEmail instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(PersonEmail persistentInstance) {
        log.debug("deleting PersonEmail instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public PersonEmail merge(PersonEmail detachedInstance) {
        log.debug("merging PersonEmail instance");
        try {
            PersonEmail result = (PersonEmail) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public PersonEmail findById(long id) {
        log.debug("getting PersonEmail instance with id: " + id);
        try {
            PersonEmail instance = (PersonEmail) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.PersonEmail", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<PersonEmail> findByExample(Example instance) {
        log.debug("finding PersonEmail instance by example");
        try {
            List<PersonEmail> results = (List<PersonEmail>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.PersonEmail")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}