package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class Person.
 * @see jim.sums3.pojo.Person
 * @author Hibernate Tools
 */
public class PersonHome {

    private static final Log log = LogFactory.getLog(PersonHome.class);

    
    public void persist(Person transientInstance) {
        log.debug("persisting Person instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(Person instance) {
        log.debug("attaching dirty Person instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(Person instance) {
        log.debug("attaching clean Person instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(Person persistentInstance) {
        log.debug("deleting Person instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Person merge(Person detachedInstance) {
        log.debug("merging Person instance");
        try {
            Person result = (Person) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public Person findById(long id) {
        log.debug("getting Person instance with id: " + id);
        try {
            Person instance = (Person) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.Person", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<Person> findByExample(Example instance) {
        log.debug("finding Person instance by example");
        try {
            List<Person> results = (List<Person>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.Person")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}