package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class PersonRoles.
 * @see jim.sums3.pojo.PersonRoles
 * @author Hibernate Tools
 */
public class PersonRolesHome {

    private static final Log log = LogFactory.getLog(PersonRolesHome.class);

    
    public void persist(PersonRoles transientInstance) {
        log.debug("persisting PersonRoles instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(PersonRoles instance) {
        log.debug("attaching dirty PersonRoles instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(PersonRoles instance) {
        log.debug("attaching clean PersonRoles instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(PersonRoles persistentInstance) {
        log.debug("deleting PersonRoles instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public PersonRoles merge(PersonRoles detachedInstance) {
        log.debug("merging PersonRoles instance");
        try {
            PersonRoles result = (PersonRoles) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public PersonRoles findById(PersonRolesId id) {
        log.debug("getting PersonRoles instance with id: " + id);
        try {
            PersonRoles instance = (PersonRoles) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.PersonRoles", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<PersonRoles> findByExample(Example instance) {
        log.debug("finding PersonRoles instance by example");
        try {
            List<PersonRoles> results = (List<PersonRoles>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.PersonRoles")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}