package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class PrizeCategories.
 * @see jim.sums3.pojo.PrizeCategories
 * @author Hibernate Tools
 */
public class PrizeCategoriesHome {

    private static final Log log = LogFactory.getLog(PrizeCategoriesHome.class);

    
    public void persist(PrizeCategories transientInstance) {
        log.debug("persisting PrizeCategories instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(PrizeCategories instance) {
        log.debug("attaching dirty PrizeCategories instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(PrizeCategories instance) {
        log.debug("attaching clean PrizeCategories instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(PrizeCategories persistentInstance) {
        log.debug("deleting PrizeCategories instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public PrizeCategories merge(PrizeCategories detachedInstance) {
        log.debug("merging PrizeCategories instance");
        try {
            PrizeCategories result = (PrizeCategories) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public PrizeCategories findById(long id) {
        log.debug("getting PrizeCategories instance with id: " + id);
        try {
            PrizeCategories instance = (PrizeCategories) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.PrizeCategories", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<PrizeCategories> findByExample(Example instance) {
        log.debug("finding PrizeCategories instance by example");
        try {
            List<PrizeCategories> results = (List<PrizeCategories>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.PrizeCategories")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}