package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class PrizeNominations.
 * @see jim.sums3.pojo.PrizeNominations
 * @author Hibernate Tools
 */
public class PrizeNominationsHome {

    private static final Log log = LogFactory.getLog(PrizeNominationsHome.class);

    
    public void persist(PrizeNominations transientInstance) {
        log.debug("persisting PrizeNominations instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(PrizeNominations instance) {
        log.debug("attaching dirty PrizeNominations instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(PrizeNominations instance) {
        log.debug("attaching clean PrizeNominations instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(PrizeNominations persistentInstance) {
        log.debug("deleting PrizeNominations instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public PrizeNominations merge(PrizeNominations detachedInstance) {
        log.debug("merging PrizeNominations instance");
        try {
            PrizeNominations result = (PrizeNominations) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public PrizeNominations findById(long id) {
        log.debug("getting PrizeNominations instance with id: " + id);
        try {
            PrizeNominations instance = (PrizeNominations) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.PrizeNominations", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<PrizeNominations> findByExample(Example instance) {
        log.debug("finding PrizeNominations instance by example");
        try {
            List<PrizeNominations> results = (List<PrizeNominations>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.PrizeNominations")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}