package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class Role.
 * 
 * @author Hibernate ToRole@see jim.sums3.pojo.Roles
 */
public class RoleHome {

    private static final Log log = LogFactory.getLog(RoleHome.class);

    
    public void persist(Role transientInstance) {
        log.debug("persisting Roles instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(Role instance) {
        log.debug("attaching dirty Roles instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(Role instance) {
        log.debug("attaching clean Roles instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(Role persistentInstance) {
        log.debug("deleting Roles instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Role merge(Role detachedInstance) {
        log.debug("merging Roles instance");
        try {
            Role result = (Role) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public Role findById(long id) {
        log.debug("getting Roles instance with id: " + id);
        try {
            Role instance = (Role) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.Roles", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<Role> findByExample(Example instance) {
        log.debug("finding Roles instance by example");
        try {
            List<Role> results = (List<Role>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.Roles")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}