package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class Staff.
 * @see jim.sums3.pojo.Staff
 * @author Hibernate Tools
 */
public class StaffHome {

    private static final Log log = LogFactory.getLog(StaffHome.class);

    
    public void persist(Staff transientInstance) {
        log.debug("persisting Staff instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(Staff instance) {
        log.debug("attaching dirty Staff instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(Staff instance) {
        log.debug("attaching clean Staff instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(Staff persistentInstance) {
        log.debug("deleting Staff instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Staff merge(Staff detachedInstance) {
        log.debug("merging Staff instance");
        try {
            Staff result = (Staff) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public Staff findById(String id) {
        log.debug("getting Staff instance with id: " + id);
        try {
            Staff instance = (Staff) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.Staff", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<Staff> findByExample(Example instance) {
        log.debug("finding Staff instance by example");
        try {
            List<Staff> results = (List<Staff>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.Staff")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}