package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class Statuses.
 * @see jim.sums3.pojo.Statuses
 * @author Hibernate Tools
 */
public class StatusesHome {

    private static final Log log = LogFactory.getLog(StatusesHome.class);

    
    public void persist(Statuses transientInstance) {
        log.debug("persisting Statuses instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(Statuses instance) {
        log.debug("attaching dirty Statuses instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(Statuses instance) {
        log.debug("attaching clean Statuses instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(Statuses persistentInstance) {
        log.debug("deleting Statuses instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Statuses merge(Statuses detachedInstance) {
        log.debug("merging Statuses instance");
        try {
            Statuses result = (Statuses) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public Statuses findById(StatusesId id) {
        log.debug("getting Statuses instance with id: " + id);
        try {
            Statuses instance = (Statuses) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.Statuses", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<Statuses> findByExample(Example instance) {
        log.debug("finding Statuses instance by example");
        try {
            List<Statuses> results = (List<Statuses>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.Statuses")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}