package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class TelNumber.
 * @see jim.sums3.pojo.TelNumber
 * @author Hibernate Tools
 */
public class TelNumberHome {

    private static final Log log = LogFactory.getLog(TelNumberHome.class);

    
    public void persist(TelNumber transientInstance) {
        log.debug("persisting TelNumber instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(TelNumber instance) {
        log.debug("attaching dirty TelNumber instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(TelNumber instance) {
        log.debug("attaching clean TelNumber instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(TelNumber persistentInstance) {
        log.debug("deleting TelNumber instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public TelNumber merge(TelNumber detachedInstance) {
        log.debug("merging TelNumber instance");
        try {
            TelNumber result = (TelNumber) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public TelNumber findById(long id) {
        log.debug("getting TelNumber instance with id: " + id);
        try {
            TelNumber instance = (TelNumber) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.TelNumber", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<TelNumber> findByExample(Example instance) {
        log.debug("finding TelNumber instance by example");
        try {
            List<TelNumber> results = (List<TelNumber>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.TelNumber")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}