package jim.sums3.pojo;

import java.math.BigDecimal;
import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class Test.
 * @see jim.sums3.pojo.Test
 * @author Hibernate Tools
 */
public class TestHome {

    private static final Log log = LogFactory.getLog(TestHome.class);

    
    public void persist(Test transientInstance) {
        log.debug("persisting Test instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(Test instance) {
        log.debug("attaching dirty Test instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(Test instance) {
        log.debug("attaching clean Test instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(Test persistentInstance) {
        log.debug("deleting Test instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Test merge(Test detachedInstance) {
        log.debug("merging Test instance");
        try {
            Test result = (Test) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public Test findById(BigDecimal id) {
        log.debug("getting Test instance with id: " + id);
        try {
            Test instance = (Test) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.Test", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<Test> findByExample(Example instance) {
        log.debug("finding Test instance by example");
        try {
            List<Test> results = (List<Test>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.Test")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}