package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class Unit.
 * @see jim.sums3.pojo.Unit
 * @author Hibernate Tools
 */
public class UnitHome {

    private static final Log log = LogFactory.getLog(UnitHome.class);

    
    public void persist(Unit transientInstance) {
        log.debug("persisting Unit instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(Unit instance) {
        log.debug("attaching dirty Unit instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(Unit instance) {
        log.debug("attaching clean Unit instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(Unit persistentInstance) {
        log.debug("deleting Unit instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Unit merge(Unit detachedInstance) {
        log.debug("merging Unit instance");
        try {
            Unit result = (Unit) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public Unit findById(long id) {
        log.debug("getting Unit instance with id: " + id);
        try {
            Unit instance = (Unit) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.Unit", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<Unit> findByExample(Example instance) {
        log.debug("finding Unit instance by example");
        try {
            List<Unit> results = (List<Unit>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.Unit")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}