package jim.sums3.pojo;

import java.util.List;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.criterion.Example;
import static org.hibernate.criterion.Example.create;



/**
 * Home object for domain model class UnitMarkForms.
 * @see jim.sums3.pojo.UnitMarkForms
 * @author Hibernate Tools
 */
public class UnitMarkFormsHome {

    private static final Log log = LogFactory.getLog(UnitMarkFormsHome.class);

    
    public void persist(UnitMarkForms transientInstance) {
        log.debug("persisting UnitMarkForms instance");
        try {
            HibernateUtil.getSession().persist(transientInstance);
            log.debug("persist successful");
        }
        catch (RuntimeException re) {
            log.error("persist failed", re);
            throw re;
        }
    }
    
    public void saveOrUpdate(UnitMarkForms instance) {
        log.debug("attaching dirty UnitMarkForms instance");
        try {
            HibernateUtil.getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void lock(UnitMarkForms instance) {
        log.debug("attaching clean UnitMarkForms instance");
        try {
            HibernateUtil.getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        }
        catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void delete(UnitMarkForms persistentInstance) {
        log.debug("deleting UnitMarkForms instance");
        try {
            HibernateUtil.getSession().delete(persistentInstance);
            log.debug("delete successful");
        }
        catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public UnitMarkForms merge(UnitMarkForms detachedInstance) {
        log.debug("merging UnitMarkForms instance");
        try {
            UnitMarkForms result = (UnitMarkForms) HibernateUtil.getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        }
        catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }
    
    public UnitMarkForms findById(long id) {
        log.debug("getting UnitMarkForms instance with id: " + id);
        try {
            UnitMarkForms instance = (UnitMarkForms) HibernateUtil.getSession()
                    .get("jim.sums3.pojo.UnitMarkForms", id);
            if (instance==null) {
                log.debug("get successful, no instance found");
            }
            else {
                log.debug("get successful, instance found");
            }
            return instance;
        }
        catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    

    public List<UnitMarkForms> findByExample(Example instance) {
        log.debug("finding UnitMarkForms instance by example");
        try {
            List<UnitMarkForms> results = (List<UnitMarkForms>) HibernateUtil.getSession()
                    .createCriteria("jim.sums3.pojo.UnitMarkForms")
                    .add( create(instance) )
                    .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        }
        catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    } 

}