/*
 * PersonDAO.java
 *
 * Created on 04 July 2006, 14:09
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package jim.sums3.process;

import java.util.Set;
import jim.sums3.pojo.Person;
import jim.sums3.pojo.PersonHome;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Restrictions;

/**
 *
 * @author briggsj
 */
public class PersonDAO extends PersonHome {
    
    private static final Log log = LogFactory.getLog(PersonDAO.class);
    
    /** Creates a new instance of PersonDAO */
    public PersonDAO() {
    }
    
    public Person findByName(String name) {
        log.debug("getting Person instance with name: " + name);
        try {
            Person instance = (Person) HibernateUtil.getSession()
            .createCriteria("jim.sums3.pojo.Person")
            .add(Restrictions.ilike("userName", name, MatchMode.EXACT)) //case insensitive match
            .uniqueResult();
            log.debug("found Person");
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    public Person findByAuthName(String name, String password) {
        log.debug("getting authenticated Person instance with name: " + name);
        Person p = findByName(name);
        if (p == null) {
            //no person with given name
            log.debug("No such person: " + name);
            return null;
        }
        if (password == null || "".equals(password)) {
            if (p.getPwd() == null) {
                log.debug("Password is null");
                return p;
            }
        }
        if (p.getPwd().equals(password)) {
            log.debug("Password authenticated");
            return p;
        } else {
            log.warn("Passwords do not match for user " + name);
            return null;
        }
    }
}
